ExamplesBasics

Layout animation

An example of animating a layout change using Motion for Vue's simple layout prop.

Vue
>Live exampleOpen

Source code

<script setup>
import { motion } from "motion-v"
import { ref } from "vue"

const isOn = ref(false)

const toggleSwitch = () => {
    isOn.value = !isOn.value
}
</script>

<template>
    <button
        :class="['toggle-container', isOn ? 'start' : 'end']"
        @click="toggleSwitch"
    >
        <motion.div
            :data-state="isOn"
            class="toggle-handle"
            layout
            :transition="{
                type: 'spring',
                visualDuration: 0.2,
                bounce: 0.2
            }"
        />
    </button>
</template>

<style>
.toggle-container {
    width: 100px;
    height: 50px;
    background-color: var(--hue-3-transparent);
    border-radius: 50px;
    cursor: pointer;
    display: flex;
    padding: 10px;
}

.toggle-container.start {
    justify-content: flex-start;
}

.toggle-container.end {
    justify-content: flex-end;
}

.toggle-handle {
    width: 50px;
    height: 50px;
    background-color: #9911ff;
    border-radius: 50%;
}
</style>

Related examples

Latest in Vue

ExamplesBasics

Layout animation

An example of animating a layout change using Motion for React's simple layout prop.

React
Live exampleOpen
Tutorial
Tutorial time
5 min
Difficulty

Introduction

The Layout Animation example shows how to create a toggle switch with smooth animation between two different layouts. It uses the layout prop from Motion for React to automatically animate changes in position.

The great thing about Motion's layout animations is you can always define your layouts as you would prefer to using CSS properties that aren't traditionally animatable, for instance switching justify-content between "flex-start" and "flex-end".

Layout animations enjoy a number of benefits over the browser's in-built view transitions:

  • Visually interruptible
  • Don't block user input
  • Backwards compatibility
  • Performance

It's also more advanced than other similar techniques like "FLIP" in libraries like GSAP as it corrects scale-induced distortion on size, position, borderRadius and boxShadow down infinitely-deep HTML trees.

Get started

Let's start with the basic structure of our toggle switch:

"use client"

import { motion } from "motion/react"
import { useState } from "react"

export default function LayoutAnimation() {
    const [isOn, setIsOn] = useState(false)

    const toggleSwitch = () => setIsOn(!isOn)

    return (
        <button
            className="toggle-container"
            style={{
                width: 100,
                height: 50,
                backgroundColor: "rgba(66, 153, 225, 0.2)",
                borderRadius: 50,
                cursor: "pointer",
                display: "flex",
                padding: 10,
                justifyContent: "flex-end",
            }}
            onClick={toggleSwitch}
        >
            <div
                className="toggle-handle"
                style={{
                    width: 50,
                    height: 50,
                    backgroundColor: "rgb(66, 153, 225)",
                    borderRadius: "50%",
                }}
            />
        </button>
    )
}

This gives us a static toggle button with a handle positioned on the right side. When clicked, the isOn state will toggle, but without animation, the handle won't visually move yet.

Let's animate!

We want to animate the "handle" element when its layout changes, and to do so we just have to add a layout prop:

<motion.div
    className="toggle-handle"
    layout

That's literally it. With just this simple change, Motion will automatically animate the handle between positions when the justifyContent value changes. The layout prop tells Motion to animate any layout changes, such as position or size.

To customize how the animation feels, we can add a transition prop:

<motion.div
    className="toggle-handle"
    style={handle}
    layout
    transition={{
        type: "spring",
        visualDuration: 0.2,
        bounce: 0.2,
    }}
/>

This transition configuration:

  • Uses a spring animation type for natural motion
  • Sets visualDuration to 0.2 seconds for a quick but visible animation
  • Reduces the bounce to 0.2 for a more controlled spring effect with less oscillation

Conclusion

In this tutorial, we've learned how to:

  1. Create a toggle switch UI component
  2. Use the layout prop to automatically animate position changes
  3. Customize the animation with spring physics

The layout prop is a powerful feature that simplifies creating smooth transitions between UI states. Without it, we'd need to manually calculate and animate positions, which would be more complex and error-prone.

This technique can be applied to many other UI elements beyond toggle switches—like expanding cards, rearranging lists, or any component that changes position or size in response to user interaction.

Source code

"use client"

import * as motion from "motion/react-client"
import { useState } from "react"

export default function LayoutAnimation() {
    const [isOn, setIsOn] = useState(false)

    const toggleSwitch = () => setIsOn(!isOn)

    return (
        <button
            className="toggle-container"
            style={{
                ...container,
                justifyContent: "flex-" + (isOn ? "start" : "end"),
            }}
            onClick={toggleSwitch}
        >
            <motion.div
                className="toggle-handle"
                style={handle}
                layout
                transition={{
                    type: "spring",
                    visualDuration: 0.2,
                    bounce: 0.2,
                }}
            />
        </button>
    )
}

/**
 * ==============   Styles   ================
 */

const container = {
    width: 100,
    height: 50,
    backgroundColor: "var(--hue-3-transparent)",
    borderRadius: 50,
    cursor: "pointer",
    display: "flex",
    padding: 10,
}

const handle = {
    width: 50,
    height: 50,
    backgroundColor: "var(--hue-3)",
    borderRadius: "50%",
}

Related examples

Latest in React